import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The bloodstream is the setting for our White Blood Cell scenario. 
 * It's a place where blood cells, bacteria and viruses float around.
 * rocketship- http://clipart-library.com/clipart/yTkA6kqgc.htm 
 * spaceship- http://clipart-library.com/clipart/BTaE5M69c.htm 
 * asteroid belt- https://www.youtube.com/watch?v=29kN95oHUlw 
 * meteor- http://www.clipartlord.com/category/space-clip-art/page/5/ 
 * star- http://clipart-library.com/clipart/riLozzp4T.htm 
 * space- https://pics-about-space.com/nasa-space-images-public-domain?p=1#img17414954041568491393
 */
public class Space extends World
{
    private int score;
    private int time;
    /**
     * Constructor: Set up the staring objects.
     */
    public Space()
    {    
        super(780, 360, 1); 
        //setPaintOrder(Borda.class);
        time = 5000;
        score = 0;
        showTime();
        showScore(); 
        prepare();
        getWorld();

    }

    private void getWorld()
    {
        int numLeaves=1;
        while (numLeaves<=10)
        {
            int x = Greenfoot.getRandomNumber(getWidth());
            int y = Greenfoot.getRandomNumber(getHeight());
            addObject (new RocketShip(), x,y);
            numLeaves++;
        }
    }

    public void act()
    {
        if (Greenfoot.getRandomNumber(100) < 3)
        {
            addObject(new Star(), 779, Greenfoot.getRandomNumber(360));
            addObject(new Meteor(), 779, Greenfoot.getRandomNumber(360));
            addObject(new AsteroidBelt(), 779, 0);
            addObject(new AsteroidBelt(), 779, 359);
        }
        countTime();
    }

    public void addScore(int points)
    {
        score = score + points;
        showScore();

        if (score < 0)
        {
            Greenfoot.playSound("game-over.wav");
            Greenfoot.stop();
            showText("You lose... Loser. Final Score: " + score, 390, 190);
        }
    }

    /**
     * Method showScore
     *
     */
    private void showScore()
    {
        showText("score:" + score, 80, 25); 
    }

    public void countTime()
    { 
        time--;
        showTime();
        if (time==0)
        {
            showEndMessage();
            Greenfoot.stop();
        }
    }

    private void showTime()
    {
        showText("Time: " + time, 700, 25);
    }

    private void showEndMessage()
    { 
        showText("You WIN!! Final Score: " + score, 390, 190);

    }

    /**
     * Create new floating objects at irregular intervals.
     */

    /**
     * Prepare the world for the start of the program. In this case: Create
     * a white blood cell and the lining at the edge of the blood stream.
     */
    private void prepare()
    {
        SpaceShip whitecell = new SpaceShip();
        addObject(whitecell, 83, 179);
        AsteroidBelt lining = new AsteroidBelt();
        addObject(lining, 126, 1);
        AsteroidBelt lining2 = new AsteroidBelt();
        addObject(lining2, 342, 5);
        AsteroidBelt lining3 = new AsteroidBelt();
        addObject(lining3, 589, 2);
        AsteroidBelt lining4 = new AsteroidBelt();
        addObject(lining4, 695, 5);
        AsteroidBelt lining5 = new AsteroidBelt();
        addObject(lining5, 114, 359);
        AsteroidBelt lining6 = new AsteroidBelt();
        AsteroidBelt lining7 = new AsteroidBelt();
        addObject(lining7, 295, 353);
        AsteroidBelt lining8 = new AsteroidBelt();
        AsteroidBelt lining9 = new AsteroidBelt();
        AsteroidBelt lining10 = new AsteroidBelt();
        addObject(lining10, 480, 358);
        AsteroidBelt lining11 = new AsteroidBelt();
        addObject(lining11, 596, 359);
        AsteroidBelt lining12 = new AsteroidBelt();
        addObject(lining12, 740, 354);
        whitecell.setLocation(81,178);
        whitecell.setLocation(230,181);
        whitecell.setLocation(229,180);
        whitecell.setLocation(162,183);

    }
}
