import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a white blood cell. This kind of cell has the job to catch 
 * bacteria and remove them from the blood.
 * 
 * http://clipart-library.com/clipart/BTaE5M69c.htm 
 */
public class SpaceShip extends Actor
{
    private int score;
    private GreenfootImage image1;
    private GreenfootImage image2;

    public SpaceShip()
    {
        image1= new GreenfootImage("spaceShipSIZED.png");
        image2= new GreenfootImage("spaceShipSIZED#2.png");
        setImage(image1);
    }

    /**
     * Act: move up and down when cursor keys are pressed.
     */
    public void act() 
    {
        checkKeyPress();
        checkCollision();
        checkRocketShip();
        checkMeteor();
        switchKeyImage();
    }

    public void switchKeyImage()
    {
        if ( getImage()== image1)
        {
            setImage(image2);
        }
        else
        {
            setImage(image1);
        }
    }

    private void checkRocketShip()
    {
        RocketShip rocketship = (RocketShip) getOneIntersectingObject (RocketShip.class);
        if (rocketship !=null)
        {
            rocketship.turn(9);
        }
    }

    private void checkMeteor()
    {
        Meteor meteor = (Meteor) getOneIntersectingObject (Meteor.class);
        if (meteor !=null)
        {
            meteor.turn(9);
        }
    }

    /**
     * Check whether a keyboard key has been pressed and react if it has.
     */
    private void checkKeyPress()
    {
        if (Greenfoot.isKeyDown("up")) 
        {
            setLocation(getX(), getY()-4);
        }

        if (Greenfoot.isKeyDown("down")) 
        {
            setLocation(getX(), getY()+4);
        }
        if (Greenfoot.isKeyDown("left"))
        {
            setLocation(getX()-4, getY());
        }
        if (Greenfoot.isKeyDown("right"))
        {
            setLocation(getX()+4, getY());
        }

    }

    private void checkCollision()
    {
        if (isTouching(Star.class))
        {
            removeTouching(Star.class);
            Greenfoot.playSound("slurp.wav");
            Space space = (Space)getWorld();
            space.addScore(20);
        }
        if (isTouching(Meteor.class))
        {
            removeTouching(Meteor.class);
            Greenfoot.playSound("game-over.wav");
            Space space = (Space)getWorld();
            space.addScore(-100);
        }
    }
}